// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/ItemModel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/item_model__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `unknown`
#include "rc_reason_msgs/msg/detail/range_box__functions.h"
// Member `rectangle`
#include "rc_reason_msgs/msg/detail/range_rectangle__functions.h"

bool
rc_reason_msgs__msg__ItemModel__init(rc_reason_msgs__msg__ItemModel * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  // unknown
  if (!rc_reason_msgs__msg__RangeBox__init(&msg->unknown)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  // rectangle
  if (!rc_reason_msgs__msg__RangeRectangle__init(&msg->rectangle)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__ItemModel__fini(rc_reason_msgs__msg__ItemModel * msg)
{
  if (!msg) {
    return;
  }
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // unknown
  rc_reason_msgs__msg__RangeBox__fini(&msg->unknown);
  // rectangle
  rc_reason_msgs__msg__RangeRectangle__fini(&msg->rectangle);
}

bool
rc_reason_msgs__msg__ItemModel__are_equal(const rc_reason_msgs__msg__ItemModel * lhs, const rc_reason_msgs__msg__ItemModel * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // unknown
  if (!rc_reason_msgs__msg__RangeBox__are_equal(
      &(lhs->unknown), &(rhs->unknown)))
  {
    return false;
  }
  // rectangle
  if (!rc_reason_msgs__msg__RangeRectangle__are_equal(
      &(lhs->rectangle), &(rhs->rectangle)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__ItemModel__copy(
  const rc_reason_msgs__msg__ItemModel * input,
  rc_reason_msgs__msg__ItemModel * output)
{
  if (!input || !output) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // unknown
  if (!rc_reason_msgs__msg__RangeBox__copy(
      &(input->unknown), &(output->unknown)))
  {
    return false;
  }
  // rectangle
  if (!rc_reason_msgs__msg__RangeRectangle__copy(
      &(input->rectangle), &(output->rectangle)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__ItemModel *
rc_reason_msgs__msg__ItemModel__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__ItemModel * msg = (rc_reason_msgs__msg__ItemModel *)allocator.allocate(sizeof(rc_reason_msgs__msg__ItemModel), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__ItemModel));
  bool success = rc_reason_msgs__msg__ItemModel__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__ItemModel__destroy(rc_reason_msgs__msg__ItemModel * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__ItemModel__Sequence__init(rc_reason_msgs__msg__ItemModel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__ItemModel * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__ItemModel *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__ItemModel), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__ItemModel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__ItemModel__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__ItemModel__Sequence__fini(rc_reason_msgs__msg__ItemModel__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__ItemModel__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__ItemModel__Sequence *
rc_reason_msgs__msg__ItemModel__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__ItemModel__Sequence * array = (rc_reason_msgs__msg__ItemModel__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__ItemModel__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__ItemModel__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__ItemModel__Sequence__destroy(rc_reason_msgs__msg__ItemModel__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__ItemModel__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__ItemModel__Sequence__are_equal(const rc_reason_msgs__msg__ItemModel__Sequence * lhs, const rc_reason_msgs__msg__ItemModel__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__ItemModel__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__ItemModel__Sequence__copy(
  const rc_reason_msgs__msg__ItemModel__Sequence * input,
  rc_reason_msgs__msg__ItemModel__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__ItemModel);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__ItemModel * data =
      (rc_reason_msgs__msg__ItemModel *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__ItemModel__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__ItemModel__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__ItemModel__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
