// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'object_to_detect'
#include "rc_reason_msgs/msg/detail/silhouette_match_object__struct.h"
// Member 'pose_frame'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/SilhouetteMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
{
  /// Required. Object that is to be detected
  rc_reason_msgs__msg__SilhouetteMatchObject object_to_detect;
  /// Optional. Shift in meters that will be applied to the calibrated base-plane
  double offset;
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request;

// Struct for a sequence of rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'object_id'
// already included above
// #include "rosidl_runtime_c/string.h"
// Member 'instances'
#include "rc_reason_msgs/msg/detail/silhouette_match_instance__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/SilhouetteMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
{
  builtin_interfaces__msg__Time timestamp;
  rosidl_runtime_c__String object_id;
  /// List of detected instances of the object
  rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence instances;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response;

// Struct for a sequence of rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_
